/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.61 Revision 1.129
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.61 2007/01/04 14:56:46 flameeyes Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.129 2012/03/22 15:14:53 vapier Exp $
4# 4
5# Author: Diego Pettenò <flameeyes@gentoo.org> 5# @ECLASS: autotools.eclass
6# Enhancements: Martin Schlemmer <azarah@gentoo.org> 6# @MAINTAINER:
7# 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION:
8# This eclass is for handling autotooled software packages that 10# This eclass is for safely handling autotooled software packages that need to
9# needs to regenerate their build scripts. 11# regenerate their build scripts. All functions will abort in case of errors.
10# 12
11# NB: If you add anything, please comment it! 13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
12 18
13inherit eutils libtool 19inherit eutils libtool
20
21# @ECLASS-VARIABLE: WANT_AUTOCONF
22# @DESCRIPTION:
23# The major version of autoconf your package needs
24: ${WANT_AUTOCONF:=latest}
25
26# @ECLASS-VARIABLE: WANT_AUTOMAKE
27# @DESCRIPTION:
28# The major version of automake your package needs
29: ${WANT_AUTOMAKE:=latest}
30
31# @ECLASS-VARIABLE: WANT_LIBTOOL
32# @DESCRIPTION:
33# Do you want libtool? Valid values here are "latest" and "none".
34: ${WANT_LIBTOOL:=latest}
35
36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37# @INTERNAL
38# @DESCRIPTION:
39# CONSTANT!
40# The latest major version/slot of automake available on each arch. #312315
41# If a newer slot is stable on any arch, and is NOT reflected in this list,
42# then circular dependencies may arise during emerge @system bootstraps.
43# Do NOT change this variable in your ebuilds!
44# If you want to force a newer minor version, you can specify the correct
45# WANT value by using a colon: <PV>[:<WANT_AUTOMAKE>]
46_LATEST_AUTOMAKE=( 1.11.1:1.11 )
14 47
15_automake_atom="sys-devel/automake" 48_automake_atom="sys-devel/automake"
16_autoconf_atom="sys-devel/autoconf" 49_autoconf_atom="sys-devel/autoconf"
17if [[ -n ${WANT_AUTOMAKE} ]]; then 50if [[ -n ${WANT_AUTOMAKE} ]]; then
18 case ${WANT_AUTOMAKE} in 51 case ${WANT_AUTOMAKE} in
19 # workaround while we have different versions of automake in arch and ~arch 52 none) _automake_atom="" ;; # some packages don't require automake at all
20 latest) _automake_atom="|| ( =sys-devel/automake-1.10* =sys-devel/automake-1.9* )" ;; 53 # if you change the "latest" version here, change also autotools_run_tool
54 # this MUST reflect the latest stable major version for each arch!
55 latest)
56 # Use SLOT deps if we can. For EAPI=0, we get pretty close.
57 if [[ ${EAPI:-0} != 0 ]] ; then
58 _automake_atom="|| ( `printf '>=sys-devel/automake-%s:%s ' ${_LATEST_AUTOMAKE[@]/:/ }` )"
59 else
60 _automake_atom="|| ( `printf '>=sys-devel/automake-%s ' ${_LATEST_AUTOMAKE[@]/%:*}` )"
61 fi
62 ;;
21 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 63 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
22 esac 64 esac
65 export WANT_AUTOMAKE
23fi 66fi
24 67
25if [[ -n ${WANT_AUTOCONF} ]] ; then 68if [[ -n ${WANT_AUTOCONF} ]] ; then
26 case ${WANT_AUTOCONF} in 69 case ${WANT_AUTOCONF} in
70 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
27 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 71 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
72 # if you change the "latest" version here, change also autotools_env_setup
28 latest | 2.5) _autoconf_atom=">=sys-devel/autoconf-2.59" ;; 73 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
74 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
29 esac 75 esac
76 export WANT_AUTOCONF
30fi 77fi
31DEPEND="${_automake_atom} 78
32 ${_autoconf_atom} 79_libtool_atom="sys-devel/libtool"
33 sys-devel/libtool" 80if [[ -n ${WANT_LIBTOOL} ]] ; then
81 case ${WANT_LIBTOOL} in
82 none) _libtool_atom="" ;;
83 latest) ;;
84 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
85 esac
86 export WANT_LIBTOOL
87fi
88
89AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
34RDEPEND="" 90RDEPEND=""
91
92# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
93# @DESCRIPTION:
94# Set to 'no' to disable automatically adding to DEPEND. This lets
95# ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
96# their own DEPEND string.
97: ${AUTOTOOLS_AUTO_DEPEND:=yes}
98if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
99 DEPEND=${AUTOTOOLS_DEPEND}
100fi
101
35unset _automake_atom _autoconf_atom 102unset _automake_atom _autoconf_atom
36 103
37# Variables: 104# @ECLASS-VARIABLE: AM_OPTS
38# 105# @DEFAULT_UNSET
39# AT_M4DIR - Additional director(y|ies) aclocal should search 106# @DESCRIPTION:
40# AM_OPTS - Additional options to pass to automake during 107# Additional options to pass to automake during
41# eautoreconf call. 108# eautoreconf call.
109
110# @ECLASS-VARIABLE: AT_NOEACLOCAL
111# @DEFAULT_UNSET
112# @DESCRIPTION:
113# Don't run eaclocal command if set to 'yes',
114# useful when eaclocal needs to be ran with
115# particular options
116
117# @ECLASS-VARIABLE: AT_NOEAUTOCONF
118# @DEFAULT_UNSET
119# @DESCRIPTION:
120# Don't run eautoconf command if set to 'yes',
121# useful when eautoconf needs to be ran with
122# particular options
123
124# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
125# @DEFAULT_UNSET
126# @DESCRIPTION:
127# Don't run eautomake command if set to 'yes',
128# useful when eautomake needs to be ran with
129# particular options
130
131# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
132# @DEFAULT_UNSET
133# @DESCRIPTION:
42# AT_NOELIBTOOLIZE - Don't run elibtoolize command if set to 'yes', 134# Don't run elibtoolize command if set to 'yes',
43# useful when elibtoolize needs to be ran with 135# useful when elibtoolize needs to be ran with
44# particular options 136# particular options
45 137
46# Functions: 138# @ECLASS-VARIABLE: AT_M4DIR
47# 139# @DESCRIPTION:
48# eautoreconf() - Should do a full autoreconf - normally what most people 140# Additional director(y|ies) aclocal should search
49# will be interested in. Also should handle additional 141: ${AT_M4DIR:=}
50# directories specified by AC_CONFIG_SUBDIRS.
51# eaclocal() - Runs aclocal. Respects AT_M4DIR for additional directories
52# to search for macro's.
53# _elibtoolize() - Runs libtoolize. Note the '_' prefix .. to not collide
54# with elibtoolize() from libtool.eclass
55# eautoconf - Runs autoconf.
56# eautoheader - Runs autoheader.
57# eautomake - Runs automake
58#
59 142
60# XXX: M4DIR should be depreciated 143# @ECLASS-VARIABLE: AT_SYS_M4DIR
61AT_M4DIR=${AT_M4DIR:-${M4DIR}} 144# @INTERNAL
62AT_GNUCONF_UPDATE="no" 145# @DESCRIPTION:
146# For system integrators, a list of additional aclocal search paths.
147# This variable gets eval-ed, so you can use variables in the definition
148# that may not be valid until eautoreconf & friends are run.
149: ${AT_SYS_M4DIR:=}
63 150
64 151# @FUNCTION: eautoreconf
152# @DESCRIPTION:
65# This function mimes the behavior of autoreconf, but uses the different 153# This function mimes the behavior of autoreconf, but uses the different
66# eauto* functions to run the tools. It doesn't accept parameters, but 154# eauto* functions to run the tools. It doesn't accept parameters, but
67# the directory with include files can be specified with AT_M4DIR variable. 155# the directory with include files can be specified with AT_M4DIR variable.
156#
157# Should do a full autoreconf - normally what most people will be interested in.
158# Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
68eautoreconf() { 159eautoreconf() {
69 local pwd=$(pwd) x auxdir 160 local x auxdir g
70 161
71 if [[ -z ${AT_NO_RECURSIVE} ]]; then 162 if [[ -z ${AT_NO_RECURSIVE} ]]; then
72 # Take care of subdirs 163 # Take care of subdirs
73 for x in $(autotools_get_subdirs); do 164 for x in $(autotools_get_subdirs); do
74 if [[ -d ${x} ]] ; then 165 if [[ -d ${x} ]] ; then
75 cd "${x}" 166 pushd "${x}" >/dev/null
76 AT_NOELIBTOOLIZE="yes" eautoreconf 167 AT_NOELIBTOOLIZE="yes" eautoreconf
77 cd "${pwd}" 168 popd >/dev/null
78 fi 169 fi
79 done 170 done
80 fi 171 fi
81 172
82 auxdir=$(autotools_get_auxdir) 173 auxdir=$(autotools_get_auxdir)
83 174
175 if [[ ${AT_NOEACLOCAL} != "yes" ]]; then
84 einfo "Running eautoreconf in '$(pwd)' ..." 176 einfo "Running eautoreconf in '${PWD}' ..."
85 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 177 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
86 eaclocal 178 eaclocal
179 fi
180 [[ ${CHOST} == *-darwin* ]] && g=g
181 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
182 _elibtoolize --copy --force --install
183 else
87 _elibtoolize --copy --force 184 _elibtoolize --copy --force
88 eautoconf 185 fi
89 eautoheader 186 [[ ${AT_NOEAUTOCONF} != "yes" ]] && eautoconf
90 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 187 [[ ${AT_NOEAUTOHEADER} != "yes" ]] && eautoheader
188 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
91 189
92 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 190 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
93 191
94 # Call it here to prevent failures due to elibtoolize called _before_ 192 # Call it here to prevent failures due to elibtoolize called _before_
95 # eautoreconf. 193 # eautoreconf. We set $S because elibtoolize runs on that #265319
96 elibtoolize 194 S=${PWD} elibtoolize --force
97 195
98 return 0 196 return 0
99} 197}
100 198
199# @FUNCTION: eaclocal_amflags
200# @DESCRIPTION:
201# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
202# (most) of the crazy crap that people throw at us.
203eaclocal_amflags() {
204 local aclocal_opts amflags_file
205
206 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
207 [[ -e ${amflags_file} ]] || continue
208 # setup the env in case the pkg does something crazy
209 # in their ACLOCAL_AMFLAGS. like run a shell script
210 # which turns around and runs autotools. #365401
211 # or split across multiple lines. #383525
212 autotools_env_setup
213 aclocal_opts=$(sed -n \
214 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
215 # match the first line
216 s:[^=]*=::p; \
217 # then gobble up all escaped lines
218 : nextline /\\\\$/{ n; p; b nextline; } \
219 }" ${amflags_file})
220 eval aclocal_opts=\""${aclocal_opts}"\"
221 break
222 done
223
224 echo ${aclocal_opts}
225}
226
227# @FUNCTION: eaclocal
228# @DESCRIPTION:
101# These functions runs the autotools using autotools_run_tool with the 229# These functions runs the autotools using autotools_run_tool with the
102# specified parametes. The name of the tool run is the same of the function 230# specified parametes. The name of the tool run is the same of the function
103# without e prefix. 231# without e prefix.
104# They also force installing the support files for safety. 232# They also force installing the support files for safety.
233# Respects AT_M4DIR for additional directories to search for macro's.
105eaclocal() { 234eaclocal() {
106 local aclocal_opts
107
108 if [[ -n ${AT_M4DIR} ]] ; then
109 for x in ${AT_M4DIR} ; do
110 case "${x}" in
111 "-I")
112 # We handle it below
113 ;;
114 *)
115 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
116 aclocal_opts="${aclocal_opts} -I ${x}"
117 ;;
118 esac
119 done
120 fi
121
122 autotools_set_versions
123 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 235 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
124 autotools_run_tool aclocal "$@" ${aclocal_opts} 236 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
125} 237}
126 238
239# @FUNCTION: _elibtoolize
240# @DESCRIPTION:
241# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
242# libtool.eclass.
127_elibtoolize() { 243_elibtoolize() {
128 local opts 244 local opts g=
129 local lttest
130 245
131 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro, 246 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
132 # check for both it and the current AC_PROG_LIBTOOL) 247 # check for both it and the current AC_PROG_LIBTOOL)
133 lttest="$(autotools_check_macro "AC_PROG_LIBTOOL")$(autotools_check_macro "AM_PROG_LIBTOOL")" 248 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
134 [[ -n $lttest ]] || return 0
135 249
136 [[ -f Makefile.am ]] && opts="--automake" 250 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
137 251
138 [[ "${USERLAND}" == "Darwin" ]] && LIBTOOLIZE="glibtoolize" 252 [[ ${CHOST} == *-darwin* ]] && g=g
139 autotools_run_tool ${LIBTOOLIZE:-libtoolize} "$@" ${opts} 253 autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
140 254
141 # Need to rerun aclocal 255 # Need to rerun aclocal
142 eaclocal 256 eaclocal
143} 257}
144 258
259# @FUNCTION: eautoheader
260# @DESCRIPTION:
261# Runs autoheader.
145eautoheader() { 262eautoheader() {
146 # Check if we should run autoheader 263 # Check if we should run autoheader
147 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 264 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
148 autotools_set_versions 265 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
149 NO_FAIL=1 autotools_run_tool autoheader "$@"
150} 266}
151 267
268# @FUNCTION: eautoconf
269# @DESCRIPTION:
270# Runs autoconf.
152eautoconf() { 271eautoconf() {
153 if [[ ! -f configure.ac && ! -f configure.in ]] ; then 272 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
154 echo 273 echo
155 eerror "No configure.{ac,in} present in '$(pwd | sed -e 's:.*/::')'!" 274 eerror "No configure.{ac,in} present in '${PWD}'!"
156 echo 275 echo
157 die "No configure.{ac,in} present!" 276 die "No configure.{ac,in} present!"
158 fi 277 fi
159 278
160 autotools_set_versions
161 autotools_run_tool autoconf "$@" 279 autotools_run_tool --at-m4flags autoconf "$@"
162} 280}
163 281
282# @FUNCTION: eautomake
283# @DESCRIPTION:
284# Runs automake.
164eautomake() { 285eautomake() {
165 local extra_opts 286 local extra_opts
287 local makefile_name
166 288
167 [[ -f Makefile.am ]] || return 0 289 # Run automake if:
290 # - a Makefile.am type file exists
291 # - the configure script is using the AM_INIT_AUTOMAKE directive
292 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
293 [[ -f ${makefile_name} ]] && break
294 done
168 295
169 autotools_set_versions 296 if [[ -z ${makefile_name} ]] ; then
297 # Really we should just use autotools_check_macro ...
298 local am_init_automake=$(sed -n '/AM_INIT_AUTOMAKE/{s:#.*::;s:\<dnl\>.*::;p}' configure.??)
299 if [[ ${am_init_automake} != *"AM_INIT_AUTOMAKE"* ]] ; then
300 return 0
301 fi
302
170 if [[ -z ${FROM_EAUTORECONF} && -f Makefile.in ]]; then 303 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
171 local used_automake 304 local used_automake
172 local installed_automake 305 local installed_automake
173 306
174 installed_automake=$(automake --version | head -n 1 | \ 307 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
175 sed -e 's:.*(GNU automake) ::') 308 sed -e 's:.*(GNU automake) ::')
176 used_automake=$(head -n 1 < Makefile.in | \ 309 used_automake=$(head -n 1 < ${makefile_name%.am}.in | \
177 sed -e 's:.*by automake \(.*\) from .*:\1:') 310 sed -e 's:.*by automake \(.*\) from .*:\1:')
178 311
179 if [[ ${installed_automake} != ${used_automake} ]]; then 312 if [[ ${installed_automake} != ${used_automake} ]]; then
180 einfo "Automake used for the package (${used_automake}) differs from" 313 einfo "Automake used for the package (${used_automake}) differs from"
181 einfo "the installed version (${installed_automake})." 314 einfo "the installed version (${installed_automake})."
182 eautoreconf 315 eautoreconf
183 return 0 316 return 0
184 fi 317 fi
185 fi 318 fi
186 319
187 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 320 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
188 || extra_opts="${extra_opts} --foreign" 321 || extra_opts="${extra_opts} --foreign"
189 322
190 # --force-missing seems not to be recognized by some flavours of automake 323 # --force-missing seems not to be recognized by some flavours of automake
191 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 324 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
192} 325}
193 326
194autotools_set_versions() { 327# @FUNCTION: eautopoint
195 [[ -n ${autotools_version_sets} ]] && return 0 328# @DESCRIPTION:
329# Runs autopoint (from the gettext package).
330eautopoint() {
331 autotools_run_tool autopoint "$@"
332}
196 333
197 if [[ -n ${WANT_AUTOCONF} ]]; then 334# @FUNCTION: config_rpath_update
198 [[ ${WANT_AUTOCONF} == "latest" ]] && WANT_AUTOCONF="2.5" 335# @USAGE: [destination]
199 export WANT_AUTOCONF 336# @DESCRIPTION:
200 einfo "Requested autoconf ${WANT_AUTOCONF}" 337# Some packages utilize the config.rpath helper script, but don't
201 einfo "Using $(autoconf --version 2>/dev/null | head -n 1)" 338# use gettext directly. So we have to copy it in manually since
202 einfo "Using $(autoheader --version 2>/dev/null | head -n 1)" 339# we can't let `autopoint` do it for us.
203 else 340config_rpath_update() {
204 ewarn "QA Notice: \${WANT_AUTOCONF} variable unset. Please report on http://bugs.gentoo.org/" 341 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
205 fi
206 342
207 if [[ -n ${WANT_AUTOMAKE} ]]; then 343 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
208 local latest_automake 344 [[ $# -eq 0 ]] && return 0
209 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then 345
210 latest_automake="latest: " 346 einfo "Updating all config.rpath files"
211 for amver in 1.10 1.9 1.8 1.7 1.6; do 347 for dst in "$@" ; do
212 WANT_AUTOMAKE="${amver}" 348 einfo " ${dst}"
213 ROOT=/ has_version =sys-devel/automake-${amver}* && break 349 cp "${src}" "${dst}" || die
214 done 350 done
215 fi
216 export WANT_AUTOMAKE
217 einfo "Requested automake ${latest_automake}${WANT_AUTOMAKE}"
218 einfo "Using $(automake --version 2>/dev/null | head -n 1)"
219 einfo "Using $(aclocal --version 2>/dev/null | head -n 1)"
220 else
221 ewarn "QA Notice: \${WANT_AUTOMAKE} variable unset. Please report on http://bugs.gentoo.org/"
222 fi
223
224 autotools_version_sets="yes"
225} 351}
226 352
227# Internal function to run an autotools' tool 353# Internal function to run an autotools' tool
354autotools_env_setup() {
355 # We do the "latest" → version switch here because it solves
356 # possible order problems, see bug #270010 as an example.
357 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
358 local pv
359 for pv in ${_LATEST_AUTOMAKE[@]/#*:} ; do
360 # has_version respects ROOT, but in this case, we don't want it to,
361 # thus "ROOT=/" prefix:
362 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="${pv}"
363 done
364 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
365 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
366 fi
367 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
368}
228autotools_run_tool() { 369autotools_run_tool() {
370 # Process our own internal flags first
371 local autofail=true m4flags=false
372 while [[ -n $1 ]] ; do
373 case $1 in
374 --at-no-fail) autofail=false;;
375 --at-m4flags) m4flags=true;;
376 # whatever is left goes to the actual tool
377 *) break;;
378 esac
379 shift
380 done
381
382 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
383 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
384 fi
385
386 autotools_env_setup
387
229 local STDERR_TARGET="${T}/$$.out" 388 local STDERR_TARGET="${T}/$1.out"
389 # most of the time, there will only be one run, but if there are
390 # more, make sure we get unique log filenames
391 if [[ -e ${STDERR_TARGET} ]] ; then
230 local ris 392 local i=1
393 while :; do
394 STDERR_TARGET="${T}/$1-${i}.out"
395 [[ -e ${STDERR_TARGET} ]] || break
396 : $(( i++ ))
397 done
398 fi
231 399
232 echo "***** $1 *****" > ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 400 if ${m4flags} ; then
233 echo >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 401 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
402 fi
403
404 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
234 405
235 ebegin "Running $@" 406 ebegin "Running $@"
236 $@ >> ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/} 2>&1 407 "$@" >> "${STDERR_TARGET}" 2>&1
237 ris=$? 408 if ! eend $? && ${autofail} ; then
238 eend ${ris}
239
240 if [[ ${ris} != 0 && ${NO_FAIL} != 1 ]]; then
241 echo 409 echo
242 eerror "Failed Running $1 !" 410 eerror "Failed Running $1 !"
243 eerror 411 eerror
244 eerror "Include in your bugreport the contents of:" 412 eerror "Include in your bugreport the contents of:"
245 eerror 413 eerror
246 eerror " ${STDERR_TARGET%/*}/$1-${STDERR_TARGET##*/}" 414 eerror " ${STDERR_TARGET}"
247 echo 415 echo
248 die "Failed Running $1 !" 416 die "Failed Running $1 !"
249 fi 417 fi
250} 418}
251 419
252# Internal function to check for support 420# Internal function to check for support
253autotools_check_macro() { 421autotools_check_macro() {
254 [[ -f configure.ac || -f configure.in ]] && \ 422 [[ -f configure.ac || -f configure.in ]] || return 0
255 WANT_AUTOCONF="2.5" autoconf --trace=$1 2>/dev/null 423 local macro
424 for macro ; do
425 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
426 done
256 return 0 427 return 0
257} 428}
258 429
430# Internal function to look for a macro and extract its value
431autotools_check_macro_val() {
432 local macro=$1 scan_out
433
434 autotools_check_macro "${macro}" | \
435 gawk -v macro="${macro}" \
436 '($0 !~ /^[[:space:]]*(#|dnl)/) {
437 if (match($0, macro ":(.*)$", res))
438 print res[1]
439 }' | uniq
440
441 return 0
442}
443
259# Internal function to get additional subdirs to configure 444# Internal function to get additional subdirs to configure
260autotools_get_subdirs() { 445autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
261 local subdirs_scan_out 446autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
262 447
263 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS") 448_autotools_m4dir_include() {
264 [[ -n ${subdirs_scan_out} ]] || return 0 449 local x include_opts
265 450
266 echo "${subdirs_scan_out}" | gawk \ 451 for x in "$@" ; do
267 '($0 !~ /^[[:space:]]*(#|dnl)/) { 452 case ${x} in
268 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res)) 453 # We handle it below
269 print res[1] 454 -I) ;;
270 }' | uniq 455 *)
456 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
457 include_opts+=" -I ${x}"
458 ;;
459 esac
460 done
271 461
272 return 0 462 echo ${include_opts}
273} 463}
464autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
465autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
274 466
275autotools_get_auxdir() { 467fi
276 local auxdir_scan_out
277
278 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
279 [[ -n ${auxdir_scan_out} ]] || return 0
280
281 echo ${auxdir_scan_out} | gawk \
282 '($0 !~ /^[[:space:]]*(#|dnl)/) {
283 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
284 print res[1]
285 }' | uniq
286
287 return 0
288}

Legend:
Removed from v.1.61  
changed lines
  Added in v.1.129

  ViewVC Help
Powered by ViewVC 1.1.20